
-- generovani CRC
-- http://www.ghsi.de/kontakt/mitarbeiter/Gorontzi/CRC/index.php?Polynom=1011&Message=A%0D%0A

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity dff is
  port (
         clk  : in std_logic;
			ce    : in std_logic;
			reset : in std_logic;
			D : in std_logic;
         Q : out std_logic
     );
end dff;

architecture DFF of dff is
begin
DFF:	process (CLK, RESET)
		begin
			if reset = '1' then
				Q <= '0';
			elsif clk = '1' and clk'event then
				if ce = '1' then
					Q <= D;		
				end if;
			end if;
		end process;
end DFF;

------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity xor_block is
  port (
         clk  : in std_logic;
			ce    : in std_logic;
			reset : in std_logic;
			fb_data : in std_logic;
			q_data : in std_logic;
 			output : out std_logic
     );
end xor_block;

architecture Behavioral of xor_block is
component dff is
  port (
         clk  : in std_logic;
			ce    : in std_logic;
			reset : in std_logic;
			D : in std_logic;
         Q : out std_logic
     );
end component;

	signal dff_out : std_logic;
begin
i_DFF: dff

	port map (
		clk => clk,
		reset => reset,
		ce => ce,
		D => q_data,
		Q => dff_out
	);

	output <= fb_data xor  dff_out;
end Behavioral;
------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity noxor_block is
  port (
         clk  : in std_logic;
			ce    : in std_logic;
			reset : in std_logic;
			fb_data : in std_logic;
			q_data : in std_logic;
--			D : in std_logic;
         output : out std_logic
     );
end noxor_block;

architecture Behavioral of noxor_block is
component dff is
  port (
         clk  : in std_logic;
			ce    : in std_logic;
			reset : in std_logic;
			D : in std_logic;
         Q : out std_logic
     );
end component;

begin
i_DFF: dff
	port map (
		clk => clk,
		reset => reset,
		ce => ce,
		D => q_data,
		Q => output
	);
end Behavioral;

------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity crc_generic is
	generic ( 
					polynom : bit_vector( 15 downto 0 ) := "1100000000000101"				
				-- CRC polynom: x^3 + x + 1
				--	polynom : bit_vector( bit_size - 1 downto 0 ) := "1011"
				);
	port (
         data : in std_logic;
			reset : in std_logic;
			ce    : in std_logic;
         clk : in std_logic;
         output : out std_logic
     );
end crc_generic;

--------------------------------------------------------------------------------
architecture Behavioral of crc_generic is
--------------------------------------------------------------------------------
component xor_block is
  port (
         clk  : in std_logic;
			ce    : in std_logic;
			reset : in std_logic;
			fb_data : in std_logic;
			q_data : in std_logic;
	
         output : out std_logic
     );
end component;
--------------------------------------------------------------------------------
component noxor_block is
  port (
         clk  : in std_logic;
			ce    : in std_logic;
			reset : in std_logic;
			fb_data : in std_logic;
			q_data : in std_logic;
	
         output : out std_logic
     );
end component;				
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
signal tmp : std_logic_vector(polynom'length downto 0); 

begin
	
konstrukce:
	for I in polynom'reverse_range generate
	--polynom'reverse_range generate
		-- nulty bit polynomu musi byt jednicka kvuli redundanci
		-- a take by nasledujici prirazeni nefungovalo
		first_block: if I = 0 generate
			inst_0: xor_block
			port map (
						reset => reset,
						clk => clk,
						ce => ce,
						q_data => tmp(I),
						fb_data => '0',
						output => tmp(I+1)
			);
		end generate;
		block_for_ones: if I > 0 and polynom(I) = '1' generate
		inst_1: xor_block 
			port map (
						reset => reset,
						clk => clk,
						ce => ce,
						q_data => tmp(I),
						fb_data => data,
						output => tmp(I+1)
			);
		end generate;
		block_for_zeros: if I > 0 and polynom(I) = '0' generate
		inst_2: noxor_block 
			port map (
						reset => reset,
						clk => clk,
						ce => ce,
						q_data => tmp(I),
						fb_data => data,
						output => tmp(I+1)
			);
		end generate;
	end generate;

  tmp(0) <= data;
  output <= tmp(polynom'length);
  
end Behavioral;

