------------------------------------------------------------------------
------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity shift_reg_test is
end shift_reg_test;

architecture Testbench of shift_reg_test is
component shift_reg is
	generic ( size : natural );
	port (
	  	CLK, RESET, CE : in std_logic;
		SERIAL_IN 	: in std_logic;
		SERIAL_OUT  : out std_logic;
		PARALEL_OUT : out std_logic_vector(size - 1 downto 0)
	);
end component;

	 constant size : natural := 8;
	 signal   CLK, RESET, CE :  std_logic;
	 signal	SERIAL_IN 	:  std_logic;
	 signal	SERIAL_OUT  :  std_logic;
	signal	PARALEL_OUT :  std_logic_vector(size - 1 downto 0);

begin
	T_Shift:	shift_reg
		generic map (size => size)
		port map (
		  	CLK =>  CLK,
			RESET => RESET,
			CE => CE,
			SERIAL_IN => SERIAL_IN,
			SERIAL_OUT => SERIAL_OUT,
			PARALEL_OUT => PARALEL_OUT
		);

hodiny: process
		  begin			
		  	CLK <= '0';
			wait for 50 ns;
			CLK <= '1';
			wait for 50 ns;
		  end process;

poc_reset: process
		begin
			RESET <= '0';
			wait for 100 ns;
			RESET <= '1';
			wait for 100 ns;
			RESET <= '0';
			wait;
		end process;

data_in: process
		begin
			SERIAL_IN <= '1';
			wait for 200 ns;
			SERIAL_IN <= '0';
			wait;
		end process;

ce_on : process
		begin
			 CE <= '0';
			 wait for 100 ns;
			 CE <= '1';
			 wait for 1000 ns;
		end process;
end;
